POJ 3281 Dinging(网络流最大流)解析

来源:互联网 发布:去北京linux培训 编辑:程序博客网 时间:2024/06/10 03:13

一、题目

Description
Cows are such finicky eaters. Each cow has a preference for certain foods and drinks, and she will consume no others.
Farmer John has cooked fabulous meals for his cows, but he forgot to check his menu against their preferences. Although he might not be able to stuff everybody, he wants to give a complete meal of both food and drink to as many cows as possible.
Farmer John has cooked F (1 ≤ F ≤ 100) types of foods and prepared D (1 ≤ D ≤ 100) types of drinks. Each of his N (1 ≤ N ≤ 100) cows has decided whether she is willing to eat a particular food or drink a particular drink. Farmer John must assign a food type and a drink type to each cow to maximize the number of cows who get both.
Each dish or drink can only be consumed by one cow (i.e., once food type 2 is assigned to a cow, no other cow can be assigned food type 2).
Input
Line 1: Three space-separated integers: N, F, and D
Lines 2..N+1: Each line i starts with a two integers Fi and Di, the number of dishes that cow i likes and the number of drinks that cow i likes. The next Fi integers denote the dishes that cow i will eat, and the Di integers following that denote the drinks that cow i will drink.
Output
Line 1: A single integer that is the maximum number of cows that can be fed both food and drink that conform to their wishes
Sample Input
4 3 3
2 2 1 2 3 1
2 2 2 3 1 2
2 2 1 3 1 2
2 1 1 3 3
Sample Output
3
Hint
One way to satisfy three cows is:
Cow 1: no meal
Cow 2: Food #2, Drink #2
Cow 3: Food #1, Drink #1
Cow 4: Food #3, Drink #3
The pigeon-hole principle tells us we can do no better since there are only three kinds of food or drink. Other test data sets are more challenging, of course.
Source
USACO 2007 Open Gold

本题能够想到用最大流做,那真的是太绝了。建模的方法很妙!
题意就是有N头牛,F个食物,D个饮料。
N头牛每头牛有一定的喜好,只喜欢几个食物和饮料。
每个食物和饮料只能给一头牛。一头牛只能得到一个食物和饮料。
而且一头牛必须同时获得一个食物和一个饮料才能满足。问至多有多少头牛可以获得满足。

二、思路

最初相当的是二分匹配。但是明显不行,因为要分配两个东西,两个东西还要同时满足。
最大流建图是把食物和饮料放在两端。一头牛拆分成两个点,两点之间的容量为1.喜欢的食物和饮料跟牛建条边,容量为1.
加个源点和汇点。源点与食物、饮料和汇点的边容量都是1,表示每种食物和饮料只有一个。
这样话完全是最大流问题了,。

手绘图有点丑
上图就是把样例按照上述方法变成最大流图的例子
其中S,T是自己设的初始点和终点,中间的三列分别代表牛,食物,饮料,你可以根据题目数据,自己把中间应该的连线画出来(我懒,就不画了)
其中首尾分别与牛和饮料的连线的流量都设为无限大,中间牛,食物,饮料的连线流量都设为1(只能用一次),这就成了标准的网络流最大流问题了。
最后计算出从S到T的最大流量(因为中间流量都是1,其实也就相当于S到T的路径总数),即为所求

三、AC代码

#include<stdio.h>#include<iostream>#include<string.h>#include<algorithm>#include<queue>using namespace std;//****************************************************//最大流模板//初始化:g[][],start,end//******************************************************const int MAXN=500;const int INF=0x3fffffff;int g[MAXN][MAXN];//存边的容量,没有边的初始化为0int path[MAXN],flow[MAXN],start,end;int n;//点的个数,编号0-n.n包括了源点和汇点。queue<int>q;int bfs(){    int i,t;    while(!q.empty())q.pop();//把清空队列    memset(path,-1,sizeof(path));//每次搜索前都把路径初始化成-1    path[start]=0;    flow[start]=INF;//源点可以有无穷的流流进    q.push(start);    while(!q.empty())    {        t=q.front();        q.pop();        if(t==end)break;        //枚举所有的点,如果点的编号起始点有变化可以改这里        for(i=0;i<=n;i++)        {            if(i!=start&&path[i]==-1&&g[t][i])            {                flow[i]=flow[t]<g[t][i]?flow[t]:g[t][i];                q.push(i);                path[i]=t;            }        }    }    if(path[end]==-1)return -1;//即找不到汇点上去了。找不到增广路径了    return flow[end];}int Edmonds_Karp(){    int max_flow=0;    int step,now,pre;    while((step=bfs())!=-1)    {        max_flow+=step;        now=end;        while(now!=start)        {            pre=path[now];            g[pre][now]-=step;            g[now][pre]+=step;            now=pre;        }    }    return max_flow;}int main(){    int N,F,D;    while(scanf("%d%d%d",&N,&F,&D)!=EOF)    {        memset(g,0,sizeof(g));        n=F+D+2*N+1;        start=0;        end=n;        for(int i=1;i<=F;i++)g[0][i]=1;        for(int i=F+2*N+1;i<=F+2*N+D;i++)g[i][n]=1;        for(int i=1;i<=N;i++)g[F+2*i-1][F+2*i]=1;        int k1,k2;        int u;        for(int i=1;i<=N;i++)        {            scanf("%d%d",&k1,&k2);            while(k1--)            {                scanf("%d",&u);                g[u][F+2*i-1]=1;            }            while(k2--)            {                scanf("%d",&u);                g[F+2*i][F+2*N+u]=1;            }        }        printf("%d\n",Edmonds_Karp());    }    return 0;}
原创粉丝点击